#ifndef IMPLICIT_ABSTRACTIONS_FORWARD_FORK_H
#define IMPLICIT_ABSTRACTIONS_FORWARD_FORK_H

#include "../task_utils/causal_graph.h"
#include "../task_proxy.h"

using namespace std;

namespace implicit {
struct ForkSuccessor {
    int var_id;
    /*int op_id;
    ForkSuccessor(int var_id, int op_id)
        : var_id(var_id), op_id(op_id)
    {}*/
    ForkSuccessor(int var_id)
            : var_id(var_id)
    {}
};
class ForwardFork {
    const int root_id;
    vector<ForkSuccessor> successors;
    vector<OperatorProxy> operators;

    /*void create_successors(
        const causal_graph::CausalGraph &cg, const OperatorProxy &  op);*/


    /*
    void get_precondition_successors(
        const causal_graph::CausalGraph &cg, const OperatorProxy &op);
    void get_effect_successors(
        const causal_graph::CausalGraph &cg, const OperatorProxy &op);
    */
    void dump();
public:
    ForwardFork(const causal_graph::CausalGraph &cg,
                const TaskProxy &task_proxy, int root_id);
    int get_root_id();
    vector<ForkSuccessor> get_successors();
    vector<int> get_variables();
    vector<OperatorProxy> get_operators();
};
}

#endif
